<?php

namespace FiloBlu\Maintenance\Observer;

use Magento\Framework\Event\ObserverInterface;

class RedirectResponseBefore implements ObserverInterface {

    protected $_helper;
    protected $storeManager;

    public function __construct(\Magento\Store\Model\StoreManagerInterface $storeManager, \FiloBlu\Maintenance\Helper\Data $helper
    ) {
        $this->_helper = $helper;
        $this->storeManager = $storeManager;
    }

    public function execute(\Magento\Framework\Event\Observer $observer) {

        $request = $observer->getRequest();
        $response = $observer->getResponse();
        $path = trim($request->getPathInfo(), '/');

        if ($this->_helper->getConfig("general/enabled")) {

            $response->setNoCacheHeaders();

            if (!$this->_helper->isAllowedIp()) {

                if ($path != "maintenance") {

                    $response->setRedirect($this->storeManager->getStore()->getBaseUrl() . "maintenance");
                    $response->sendResponse();
                }
            }
        } else {

            if ($path == "maintenance") {

                $response->setNoCacheHeaders();
                
                if (!$this->_helper->isAllowedIp()) {
                    $response->setRedirect($this->storeManager->getStore()->getBaseUrl());
                    $response->sendResponse();
                }
            }
        }
    }

}
